# grafana-stack-in-kubernetes

![https://ithelp.ithome.com.tw/upload/images/20230916/20149562RdEO0SrN11.png](https://ithelp.ithome.com.tw/upload/images/20230916/20149562RdEO0SrN11.png)

# 目錄

接下來的日子裡，我將依自己的學習經驗為大夥由淺到稍微不淺的了解 Kubernetes 中的 `Grafana 全家桶` ，有興趣的同學可以先參考參考。

## 概念篇：萬丈高樓平地起，開始爬吧

- [可觀測性宇宙的第二天 - Kubernetes 介紹](https://ithelp.ithome.com.tw/articles/10320414)
- [可觀測性宇宙的第三天 - 可觀測性和監控是什麼？](https://ithelp.ithome.com.tw/articles/10321728)
- [可觀測性宇宙的第四天 - 可觀測性三本柱是什麼？](https://ithelp.ithome.com.tw/articles/10322323)
- [可觀測性宇宙的第五天 - 第四種可觀測性訊號？ Profile](https://ithelp.ithome.com.tw/users/20149562/ironman/6674)
- [可觀測性宇宙的第六天 - Grafana 上的可觀測性宇宙](https://ithelp.ithome.com.tw/articles/10324046)

## 行前準備篇：一個蘿蔔一個坑，看倌請入坑

- [可觀測性宇宙的第七天 - Kubernetes 安裝（docker desktop for mac）](https://ithelp.ithome.com.tw/articles/10324886)
- [可觀測性宇宙的第八天 - Kubernetes Lens 推坑 K8S GUI 神器介紹](https://ithelp.ithome.com.tw/articles/10325689)
- [可觀測性宇宙的第九天 - Helm 安裝包管理器介紹](https://ithelp.ithome.com.tw/articles/10326496)

## Prometheus 篇：現代監控世界的催生者

- [可觀測性宇宙的第十天 - Prometheus 介紹](https://ithelp.ithome.com.tw/articles/10327258)
- [可觀測性宇宙的第十一天 - Prometheus 基本觀念 - PromQL](https://ithelp.ithome.com.tw/articles/10328588)
- [可觀測性宇宙的第十二天 - Prometheus 全家桶介紹](https://ithelp.ithome.com.tw/articles/10329207)
- [可觀測性宇宙的第十三天 - Kube-Prometheus-Stack 實戰（一）](https://ithelp.ithome.com.tw/articles/10329845)
- [可觀測性宇宙的第十四天 - Kube-Prometheus-Stack 實戰（二）](https://ithelp.ithome.com.tw/articles/10330704)
- [可觀測性宇宙的第十五天 - Kube-Prometheus-Stack 實戰（三）](https://ithelp.ithome.com.tw/articles/10331330)

## Grafana 篇：探索可觀測性宇宙的起源

- [可觀測性宇宙的第十六天 - Grafana 入門介紹](https://ithelp.ithome.com.tw/articles/10332031)
- [可觀測性宇宙的第十七天 - Grafana 10 搶先看](https://ithelp.ithome.com.tw/articles/10332710)
- [可觀測性宇宙的第十八天 - Grafana Cloud - Kubernetes Monitoring 實戰介紹](https://ithelp.ithome.com.tw/articles/10333406)

## Grafana Agent 篇：如果有一天，世界沒有任何隔閡

- [可觀測性宇宙的第十九天 - Grafana Agent 介紹 - 交織可觀測性的鵲橋](https://ithelp.ithome.com.tw/articles/10334036)
- [可觀測性宇宙的第二十天 - Grafana Agent - Static mode Kubernetes Operator 實戰](https://ithelp.ithome.com.tw/articles/10334635)
- [可觀測性宇宙的第二十一天 - Grafana Agent - Flow mode 實戰](https://ithelp.ithome.com.tw/articles/10335237)

## Grafana Loki 篇：有些東西應該如 grep 般簡單且成本低廉

- [可觀測性宇宙的第二十二天 - Grafana Loki 介紹 - 性價比的王者](https://ithelp.ithome.com.tw/articles/10335935)
- [可觀測性宇宙的第二十三天 - Grafana Loki 實戰](https://ithelp.ithome.com.tw/articles/10336360)
- [可觀測性宇宙的第二十四天 - Grafana Loki 效能調校](https://ithelp.ithome.com.tw/articles/10336979)

## Grafana Tempo 篇：不斷追尋的過程中也不斷錯過

- [可觀測性宇宙的第二十五天 - Grafana Tempo 介紹 - 容納百川的盡頭](https://ithelp.ithome.com.tw/articles/10337516)
- [可觀測性宇宙的第二十六天 - Grafana Tempo 實戰](https://ithelp.ithome.com.tw/articles/10338074)
- [可觀測性宇宙的第二十七天 - Grafana Tempo 效能調校](https://ithelp.ithome.com.tw/articles/10338515)

## Grafana Mimir 篇：每件事物的存在都有其意義

- [可觀測性宇宙的第二十八天 - Grafana Mimir 介紹 - 監控指標的應許之地](https://ithelp.ithome.com.tw/articles/10338987)
- [可觀測性宇宙的第二十九天 - Grafana Mimir 實戰](https://ithelp.ithome.com.tw/articles/10339435)

## 結語：只有虛無，在寂靜的宇宙中

- [可觀測性宇宙的第三十天 - Grafana 全家桶最終章，接下來呢](https://ithelp.ithome.com.tw/articles/10339834)

## Bonus：如果當初還能為你多做些什麼

- [可觀測性宇宙的第三十一天 - Grafana Tempo 搭配 Odigos 實現 NoCode Observability](https://ithelp.ithome.com.tw/articles/10340539)
---

- Github：https://github.com/MikeHsu0618
- Facebook：https://www.facebook.com/mike.hsu.775
- Gmail：a3695821tw11@gmail.com