# 可觀測性宇宙的第三十天 - Grafana 全家桶最終章，接下來呢

![cover](https://source.unsplash.com/random/1600x900/?space)
# 前言

不敢相信自己就這樣從幾個月前開始準備的鐵人賽，到近兩個月來的水深火熱，一轉眼就到了最後一天。早在今年初，轉換了新環境，脫離世界奇景般的機車瀑布台北橋，踏入了地靈人傑的士林區，直到漸漸熟悉環境時，一抬頭馬上到了五月初夏的季節。這時我又想起，鐵人賽好像又要來臨了，回想去年備賽鐵人賽的時光中，利用工作上使用到的技能，加上自己下班後的研究心得，今年是否還可以掀起一波自虐之旅呢？本來替自己不想花太多時間在寫文章上的開脫之詞，在兩位重要隊友的加入後灰飛雲散，甚至接受了出版社的出版去年系列文「[從異世界歸來發現只剩自己不會 Kubernetes](https://ithelp.ithome.com.tw/users/20149562/ironman/5366)」的邀請，加上其他開源社群志工、講者的任務都高度重疊在一起，今年下半年可以說是超越去年的燃燒生命。

# 驗收過去的一年

在去年鐵人賽完賽時，隨手寫下了自己未來的[學習路線](https://ithelp.ithome.com.tw/articles/10300813)：

> 接下來將跟各位分享一下自己準備繼續鑽研的路線，可以簡單的分為三個部分： Templating 、Service Mesh 、Monitoring ，這些可以說是得益於容器化以及微服務下的時代潮流。有了 Kubernetes 這種容器編排工具使得多環境部署更加方便，催生出了可以重複使用降低耦合度的 Kubernetes 設定檔模版 - Helm；而微服務的興起也代表著每個服務之間的溝通過程越發重要，也使得有個統一溝通中心的 Server Mesh 的概念被提出，其中最具代表性的工具一定是 istio；而當微服務越發龐大複雜時，排查錯誤的難度也指數上升，此時我們需要一個超脫一切生命週期的地方，井然有序的儲存我們的日誌，並且時刻監控資源，這時許多人一定會想到 Grafana 和 Prometheus 這套威猛組合拳，光是以上提及的服務就足已使我們踏入第四與第五層深淵，更足以讓我們繼續折騰下一個半年。
>

現在看起來，還真的都有去把這個清單一個一個 Checked 掉！從先學習 Helm 的基本操作，當作入門雲原生的第一步，再到使用 Grafana 跟 Prometheus 認識到的可觀測性。終於理解了 Service Mesh 厲害之處不只局限於 API Gateway，沒想到他竟然也和可觀測性息息相關。這一切拆開來看似沒有關聯，卻是引導我一步一步的深掘 Grafana 全家桶的重要關鍵，缺一不可。

# 繼續擴展我們的宇宙

在本系列文章中，我們深度探索了 Grafana LGTM 全方位使用以及 Kubernetes 的可觀測性宇宙。雖然目前已經掌握了可觀測性三本柱，似乎已站在這領域的前沿，但我們不能忽視像 Grafana Labs 這樣的團隊仍持續快速創新。事實上，觀察整個 Grafana 生態，我們這次只涉及了其中不足一半的工具。還有更多未知領域在等待我們去挖掘和開發。

雖然我們尚未充分利用 Grafana Labs 在可觀測性三本柱上的全部潛力，但我們可以通過他們在其他領域的開源專案，進一步交叉深化我們的基礎知識。例如，專為前端監控設計的 Grafana Faro，以及代表新興的第四要素「持續分析」的 Grafana Pyoscope。同時，我們還要留意像 Opentelemetry 這樣與社群共同發展的工具，它正在逐步整合這個領域的各種工具。也許有一天，我們會驚訝地發現，過去熟悉的某些工具已經不再被廣泛使用。

因此，我們應該持續學習新技術，深入了解其運作機制。只有這樣，我們才能在這個不斷變化的世界中，保持領先，並適應每一次的創新。

![https://ithelp.ithome.com.tw/upload/images/20231015/20149562Gdvc2ubPLS.png](https://ithelp.ithome.com.tw/upload/images/20231015/20149562Gdvc2ubPLS.png)

# 結語

首先要恭喜各個堅持到這裡的鐵人們，三十天三十篇文章，背後經歷著無數下班後奮鬥的夜晚，只有每位鐵人自己知道。對於我在自己研究 Grafana LGTM 全家桶的感想就是「東西太新了，文件不夠啊！」，Tempo 與 Mimir 分別是在 2021 以及 2022 年推出，Chatgpt 沒辦法更新到資訊，加上官方文件也尚未補齊。就算是以較為成熟的 Loki 來說，其進化的速度，還是快到文件沒辦法跟上，許多資訊只能從 Github 專案中挖掘，尤其是那個說淘汰就淘汰的索引存儲機制。甚至某個 Grafana 核心團隊成員表示：「因為 Grafana 專案每天都在進步，所以沒辦法輕易地給出建議調教參數」。

同時也感謝這次陪我一起參賽的兩位強大的隊友，至少今年我不再是一個人踽踽獨行。這對我來說意義非凡，因為打從自學轉職成工程師以來，一路上都是自己面對著 Google 和線上教學影片，在數不盡的夜晚裡重複著。而現在我也找到可以互相倚賴的強大隊友，內心有種說不出的激動！也向大家分享他們的精彩傑作。

### 所以隊名要叫什麼

- **[營養師不開菜單要用 Next.js 13 寫全端](https://ithelp.ithome.com.tw/users/20152073/ironman/6676)**
- **[Laravel 擴展宇宙：從 1 到 100 十倍速打造產品獨角獸](https://ithelp.ithome.com.tw/users/20161837/ironman/6684)**

---

最後，我將會繼續往 Grafana 與可觀測性領域深掘，並且開始補足在這次鐵人賽中，有人敲碗或來不急寫成文章的內容。如果對我分享的內容有任何有興趣的人，請不用客氣的使用各種方式讓我知道，並且與我分享交流。

- GIthub：https://github.com/MikeHsu0618
- Facebook：https://www.facebook.com/mike.hsu.775
- Gmail：a3695821tw11@gmail.com